package com.gxwebsoft.shop.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.common.system.service.UserService;
import com.gxwebsoft.shop.service.MerchantClerkService;
import com.gxwebsoft.shop.entity.MerchantClerk;
import com.gxwebsoft.shop.param.MerchantClerkParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商家门店店员表控制器
 *
 * @author 科技小王子
 * @since 2022-11-30 16:32:25
 */
@Api(tags = "商家门店店员表管理")
@RestController
@RequestMapping("/api/shop/merchant-clerk")
public class MerchantClerkController extends BaseController {
    @Resource
    private MerchantClerkService merchantClerkService;
    @Resource
    private UserService userService;

    @PreAuthorize("hasAuthority('shop:merchantClerk:list')")
    @OperationLog
    @ApiOperation("分页查询商家门店店员表")
    @GetMapping("/page")
    public ApiResult<PageResult<MerchantClerk>> page(MerchantClerkParam param) {
        PageParam<MerchantClerk, MerchantClerkParam> page = new PageParam<>(param);
//        page.setDefaultOrder("create_time desc");
//        return success(merchantClerkService.page(page, page.getWrapper()));
        // 使用关联查询
        return success(merchantClerkService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:merchantClerk:list')")
    @OperationLog
    @ApiOperation("查询全部商家门店店员表")
    @GetMapping()
    public ApiResult<List<MerchantClerk>> list(MerchantClerkParam param) {
        PageParam<MerchantClerk, MerchantClerkParam> page = new PageParam<>(param);
//        page.setDefaultOrder("create_time desc");
//        return success(merchantClerkService.list(page.getOrderWrapper()));
        // 使用关联查询
        return success(merchantClerkService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:merchantClerk:list')")
    @OperationLog
    @ApiOperation("根据id查询商家门店店员表")
    @GetMapping("/{id}")
    public ApiResult<MerchantClerk> get(@PathVariable("id") Integer id) {
        return success(merchantClerkService.getById(id));
        // 使用关联查询
        //return success(merchantClerkService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:merchantClerk:save')")
    @OperationLog
    @ApiOperation("添加商家门店店员表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MerchantClerk merchantClerk) {
        // 判断用户ID是否存在
        User user = userService.getById(merchantClerk.getUserId());
        if(user != null){
          // 防止重复
          if (merchantClerkService.count(new LambdaQueryWrapper<MerchantClerk>()
            .eq(MerchantClerk::getUserId, merchantClerk.getUserId())) > 0) {
            return fail("该用户已被绑定");
          }
          if (merchantClerkService.save(merchantClerk)) {
            return success("添加成功");
          }
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantClerk:update')")
    @OperationLog
    @ApiOperation("修改商家门店店员表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MerchantClerk merchantClerk) {
        if (merchantClerkService.updateById(merchantClerk)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantClerk:remove')")
    @OperationLog
    @ApiOperation("删除商家门店店员表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (merchantClerkService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantClerk:save')")
    @OperationLog
    @ApiOperation("批量添加商家门店店员表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MerchantClerk> list) {
        if (merchantClerkService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantClerk:update')")
    @OperationLog
    @ApiOperation("批量修改商家门店店员表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MerchantClerk> batchParam) {
        if (batchParam.update(merchantClerkService, "clerk_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantClerk:remove')")
    @OperationLog
    @ApiOperation("批量删除商家门店店员表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (merchantClerkService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
